/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.Marshal
 *  fire.log.Module
 *  fire.pb.StateCommon
 *  fire.pb.exception.CodecException
 *  fire.pb.map.RoleManager
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xbean.OfflineMsgList
 *  xbean.OfflineMsgProtocol
 *  xbean.Pod
 *  xtable.Offlinemsg
 */
package fire.pb.friends;

import com.locojoy.base.Marshal.Marshal;
import fire.log.Module;
import fire.pb.StateCommon;
import fire.pb.exception.CodecException;
import fire.pb.map.RoleManager;
import java.util.List;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xbean.OfflineMsgList;
import xbean.OfflineMsgProtocol;
import xbean.Pod;
import xtable.Offlinemsg;

public class OffLineMessageManager {
    private static OffLineMessageManager offLineMsgManager;

    private OffLineMessageManager() {
    }

    public static synchronized OffLineMessageManager getOffLineMsgManager() {
        if (null == offLineMsgManager) {
            offLineMsgManager = new OffLineMessageManager();
        }
        return offLineMsgManager;
    }

    public boolean isOnline(long roleid) {
        return StateCommon.isOnline((long)roleid);
    }

    public boolean isOnlineUnsafe(long roleid) {
        return RoleManager.getInstance().getRoleByID(roleid) != null;
    }

    public int isOnlineIntValue(long roleid) {
        return StateCommon.isOnline((long)roleid) ? 1 : 0;
    }

    public void inserteOfflineMsgById(final long roleId, final Protocol msg) {
        Procedure proc = new Procedure(){

            protected boolean process() throws Exception {
                OfflineMsgProtocol pro = Pod.newOfflineMsgProtocol();
                pro.setProclassname(OffLineMessageManager.this.getProtocolClassName(msg));
                pro.setProtype(msg.getType());
                pro.setContent((Marshal)msg);
                pro.setTick(System.currentTimeMillis());
                OfflineMsgList list = Offlinemsg.get((Long)roleId);
                if (null == list) {
                    list = Pod.newOfflineMsgList();
                    list.getProtocollist().add(pro);
                    Offlinemsg.insert((Long)roleId, (OfflineMsgList)list);
                    return true;
                }
                list.getProtocollist().add(0, pro);
                if (list.getProtocollist().size() > 20) {
                    for (int i = list.getProtocollist().size() - 1; i >= 20; --i) {
                        list.getProtocollist().remove(i);
                    }
                }
                return true;
            }
        };
        if (Transaction.current() != null) {
            Procedure.pexecuteWhileCommit((Procedure)proc);
        } else {
            proc.submit();
        }
    }

    private String getProtocolClassName(Protocol msg) throws CodecException {
        String str = msg.getClass().toString();
        String[] strArray = str.split(" ");
        if (strArray.length < 2) {
            throw new CodecException("保存离线消息的class name出错！！！");
        }
        return strArray[1];
    }

    public boolean executeOfflineMsgById(long roleId) {
        OfflineMsgList list = Offlinemsg.get((Long)roleId);
        if (null == list) {
            list = Pod.newOfflineMsgList();
            Offlinemsg.insert((Long)roleId, (OfflineMsgList)list);
            return true;
        }
        List msgs = list.getProtocollist();
        if (null == msgs || msgs.size() == 0) {
            return true;
        }
        for (OfflineMsgProtocol msg : msgs) {
            Protocol content = null;
            try {
                Class<?> protocolCls = Class.forName(msg.getProclassname());
                Protocol protocol = (Protocol)protocolCls.newInstance();
                content = (Protocol)msg.getContent((Marshal)protocol);
            }
            catch (Exception e) {
                Module.logger.error((Object)"Recv offline protocol Class reflection error!", (Throwable)e);
                Module.logger.debug((Object)("Recv offline protocol:" + msg.getProclassname()));
                continue;
            }
            catch (Error e) {
                Module.logger.debug((Object)("Recv offline protocol:" + msg.getProclassname()));
                Module.logger.error((Object)"Recv offline protocol error! may now protocol != db save protocol", (Throwable)e);
                continue;
            }
            Procedure.psendWhileCommit((long)roleId, (Protocol)content);
        }
        msgs.clear();
        return true;
    }
}

